function z=clarkmodel(N)

% This function is based on Clarke's Model which is and statistical model
% for flat fading
%
% N: Number of points
% fc: Central frecuency
% v: velocity
% a2: a^2 is the total recived energy along all paths
% W: Bandwidth (much smaller than the reciprocal of the delay spread)
% Ds: Doppler spread


c=3e8;
f=linspace(-1/2,1/2,N);
S=zeros(1,N);
%a2=0.5;fc=1e9;v=3;W=5e3; % For R_0
a2=1;fc=1.92e9;v=3;W=1e2; % For S

Ds=2*fc*v/c;

%---------------------------Jake's Spectrum---------------------------------
for i=1:N
    if f(i)<=(Ds/2*W) && f(i)>=-(Ds/2*W)
        S(i)=4*a2*W/(Ds*sqrt( 1-(2*f(i)*W/Ds)^2 ));
    end
end

plot(f,real(S))
xlabel('frequency'),ylabel('S(f)');
%--------------------------------------------------------------------------

%----------------------------Autocorrelation-------------------------------
% n=0:2047;
% 
% R=2*a2*pi*besseli(0,n*pi*Ds/W);

% plot(n,R);
% axis([0 2000 -1.5 3.5]),ylabel('R_0[n]'),xlabel('samples')
%--------------------------------------------------------------------------


%X=[S(a:end) S(a:-1:1)];

A=fft(randn(1,N));
B=fft(randn(1,N));
Z=[S(N/2+1:N)];

Z=S.*A-i*S.*B;
% S(1:N/2)];
z=ifft(Z);

%-----------------------other model----------------------------------------

% f=linspace(-441000,441000,N);
% S=zeros(1,N);
% sigmap=10^(7/1);
% 
% fc=1.92e9;c=3e8;v=3;
% fm=fc*v/c;
% 
% for i=1:N
%     if abs(f(i))<=fm
%         S(i)=sigmap/(2*pi*fm*sqrt(1-(f(i)/fm)^2));
%     end
% end
% plot(f,abs(S));
% 
% A=randn(1,N);
% B=randn(1,N);
% Z=A.*z-i*B.*z;
% fa=ifft(Z);
% z=fa;