function [fading, tc]=genfading(type,fd,ts,N,delta,varargin)

%[fading, tc]=calcfading(type,fd,ts,N,delta,k)
%
%This function returns fadind samples and the coherence time
%
% type: Can be 'rayleigh or rice. 
% fd(Hz): maximun Doppler shift =fc*v/c
% ts is the sample time of the input signal, in seconds. 1/44100
% N: Number of samples
% delta: is the average error permited within Tc samples, usually 0.01
% k: k factor for rician fading

x=ones(1,N);

if strcmp(type,'rayleigh')
    c1 = rayleighchan(ts,fd);
    y=filter(c1, x);
    fading=abs(y);
elseif strcmp(type,'rice')
    if nargin==6
        c1 = ricianchan(ts,fd,varargin{1});
        y=filter(c1, x);
        fading=abs(y);
    else
        error('k factor is undefined')
    end
else
    error('Incorrect fading type. Should be "rice" or rayleigh"');
end
tc=1;
% u=1;
% j=1;
% tcc=[];
% for i=1:length(fading)
%     k=abs(fading(u)-fading(i));
%     if k>=delta
%         tcc=[tcc i-u];
%         u=i;
%     end
% end
% 
% tc=round(mean(tcc));