function obtainMopt(N)

% This function plots the SNR whrn varying the expansion factor to obtain
% the optimum expansion factor 

EsN0=12;SigmaX=0;SigmaN=0;
M=1:40;%tc=[1 2 4 10 20];
SNR=zeros(1,length(M));
x=randn(1,N)*sqrt(1);
noise=randn(50+1,N)*sqrt(1);

% Rician fading with low variance
[fading, tcc]=genfading('rice',19.2,1/(44100*16),N*2*max(M),0.01,100);
fading=fading/mean(fading);fading=fading/2+(1-1/2);

tc=10;
power=zeros(1,length(M));
for i=1:length(M)
    [SNR(i) powerri(i)]=fadingfeedback(x,EsN0,M(i),N,SigmaX,SigmaN,noise,fading,tc);
end


figure();

subplot(1,2,1)
plot(M,SNR)
grid on; xlabel('Expansion factor M'),ylabel('SNR (dB)'),title('Rician fading')
axis([1 20 0 80])

maximum=M(find(SNR==max(SNR)))


%**************************************************************************
%**************************************************************************
SNR=zeros(1,length(M));

%Rayleigh fading---------------------------------------------------
[fading, tcc]=genfading('rayleigh',1,1/44100,N*16*5,0.01);

tc=1;
powerra=zeros(1,length(M));

for i=1:length(M)
    [SNR(i),powerra(i)]=fadingfeedback(x,EsN0,M(i),N,SigmaX,SigmaN,noise,fading,tc);
end


subplot(1,2,2)
plot(M,SNR)
grid on;xlabel('Expansion factor M'),ylabel('SNR (dB)'),title('Rayleigh fading')
axis([0 20 0 80])

maximum=M(find(SNR==max(SNR)))



function [SNR,power]=fadingfeedback(x,Es,M,N,SigmX,SigmN,noise,fading,Tc)

% Es(dB): Energy per source sample (0~20 dB)
% M: Expansion factor
% N: Number of samles
% SigmaX: Signal variance
% SigmaN: Channel noise power

Esl=10^(Es/10);
SigmaX=10^(SigmX/10);
SigmaN=10^(SigmN/10);

%--------------------Calculate coeficients----------------------------------
A=zeros(1,M+1);B=zeros(1,M+1);D=zeros(1,M+1);
A(1)=1;B(1)=1;D(1)=SigmaX;
for i=2:(M+1)
    A(i)=sqrt((2*Esl/M)/D(i-1));
    B(i)=sqrt(D(i-1)*(2*Esl/M))/((2*Esl/M)+SigmaN);
    D(i)=D(i-1)*SigmaN/((2*Esl/M)+SigmaN);
end
%--------------------------------------------------------------------------

out=zeros(1,N);
fadingcount=1;
power=zeros(1,N);
pulse=3;
u=0;%to increase the fading

d=pulse*fading(1); %Send pulse to measure fading
betaa=pulse/d;
for n=1:N
    d=0;
    y=0;
    if fadingcount==Tc
        fadingcount=0;u=u+1;
        d=pulse*fading(u); %Send pulse to measure fading
        betaa=pulse/d;
    end
    pow=zeros(1,M);
    for i=2:M+1
        u=u+1;
        a=(x(n)-d)*A(i)*betaa;
        pow(i-1)=a;
        b=a*fading(u)+noise(i,n);
        c=b*B(i);
        y=c+y;
        d=y*fading(u)*betaa;
    end
    out(n)=y;
    power(n)=sum(pow.^2);
    fadingcount=fadingcount+1;
end

power=(1/(N*M))*sum(power);
outputnoise=x-out;
SNR=10*log10(SigmaX/var(outputnoise));