function [out,SNR,power]=systemNObuffer(x,Es,M,SigmX,SigmN,noise,fading,Tc,maxbeta)

% Es(dB): Energy per source sample (0~20 dB)
% M: Expansion factor
% N: Number of samles
% SigmaX: Signal variance
% SigmaN: Channel noise power


x=(x(:))';
Esl=10^(Es/10);
SigmaX=10^(SigmX/10);
SigmaN=10^(SigmN/10);
maxbeta=10^(maxbeta/10);
N=length(x);
pulse=4;

%--------------------Calculate coeficients----------------------------------
A=zeros(1,M+1);B=zeros(1,M+1);D=zeros(1,M+1);
A(1)=1;B(1)=1;D(1)=SigmaX;
for i=2:(M+1)
    A(i)=sqrt((2*Esl/M)/D(i-1));
    B(i)=sqrt(D(i-1)*(2*Esl/M))/((2*Esl/M)+SigmaN);
    D(i)=D(i-1)*SigmaN/((2*Esl/M)+SigmaN);
end
%--------------------------------------------------------------------------

out=zeros(1,N);
power=zeros(1,N);
fadingcount=1;
u=1;%to increase the fading

d=pulse*fading(1); %Send pulse to measure fading
betaa=pulse/d;
for n=1:N
    d=0;
    y=0;
    if fadingcount==Tc
        fadingcount=0;u=u+1;
        d=pulse*fading(u); %Send pulse to measure fading
        betaa=pulse/d;
    end
    if betaa>maxbeta
        betaa=maxbeta;
    end
    
    pow=zeros(1,M);
    for i=2:M+1
        u=u+1;
        a=(x(n)-d)*A(i)*betaa;
        pow(i-1)=a;
        b=a*fading(u)+noise(i,n);
        c=b*B(i);
        y=c+y;
        d=y*fading(u)*betaa;
    end
    power(n)=sum(pow.^2);
    out(n)=y;
    fadingcount=fadingcount+1;
end

power=(1/(N*M))*sum(power);
outputnoise=x-out;
SNR=10*log10(SigmaX/var(outputnoise));